Unit ASK2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASK2C(var A1 :Array of Complex; var B :Array of Complex;
                var Y :Array of Complex; var B3 :Array of Complex;
                var L :Array of Integer; var N :Array of Integer;
                var C :Array of Complex; var Q :Array of Integer;
                M :Integer; P :Integer);

implementation

procedure ASK2C(var A1 :Array of Complex; var B :Array of Complex;
                var Y :Array of Complex; var B3 :Array of Complex;
                var L :Array of Integer; var N :Array of Integer;
                var C :Array of Complex; var Q :Array of Integer;
                M :Integer; P :Integer);
var
I,J,K,D,E,F,G,V,W,Z,BA,BB,BD,BE,BF,BG,BH,BI,BJ,BK,BL,BN,BT,CC,
   CK :Integer;
A,BQ,BR,BS,BW,BX,BY,CA,CD,CI,CL,CU,CX :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_100,_14,_101,_15,_16,_17,
_18,_19,_20,_21,_22,_23,_231,_232,_233,_24,_25,_26,_27,_28,_29,_30,
_31,_32,_33,_34,_35,_36,_37,_102,_38,_39,_40,_41,_103,_42,_104,_43,
_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,_54,_55,_56,_57,_58,_59,_60,
_61,_62,_63,_64,_65,_66,_67,_68,_69,_70,_71,_72,_73,_74,_75,_76,_77,
_78,_79,_80,_81,_82,_83,_84,_85,_86,_87,_88,_89,_90;
begin
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_1:
    B3[(I-1)+(J-1)*M+0*M*M] := A1[(I-1)+(J-1)*M+0*M*M];
   end;
 end;
if ( M > 1 ) 
 then goto _2;
B3[0+0*M+0*M*M] := DivC(Cmplx(1.0,0.0),B3[0+0*M+0*M*M]);
goto _18;
_2:
V := 1;
W := 1;
_3:
J := W;
BN := V;
BQ := Cmplx(0.0,0.0);
for I:=V to M do
 begin
  CA := Cmplx(Cabs(B3[(I-1)+(J-1)*M+0*M*M]),0.0);
  if ( (Cabs(BQ)) >=     (Cabs(CA)) ) 
   then goto _4;
  BQ := CA;
  BN := I;
_4:
 end;
for J:=1 to M do
 begin
  CU := B3[(BN-1)+(J-1)*M+0*M*M];
  B3[(BN-1)+(J-1)*M+0*M*M] := B3[(V-1)+(J-1)*M+0*M*M];
  B3[(V-1)+(J-1)*M+0*M*M] := CU;
_5:
 end;
C[(V-1)+1*M+1*M*M] := B3[(V-1)+(W-1)*M+0*M*M];
Q[V-1] := BN;
J := W;
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := B3[(I-1)+(J-1)*M+0*M*M];
_6:
 end;
BR := DivC(Cmplx(1.0,0.0),C[(V-1)+0*M+1*M*M]);
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := SubC(Cmplx(0.0,0.0),MulC(C[(I-1)+0*M+1*M*M],BR));
_7:
 end;
C[(V-1)+0*M+1*M*M] := BR;
BF := 0;
_8:
BF := BF+1;
if ( M < BF ) 
 then goto _11;
CD := B3[(V-1)+(BF-1)*M+0*M*M];
CC := V-1;
for BG:=1 to CC do
 begin
  B3[(BG-1)+(BF-1)*M+0*M*M] := AddC(B3[(BG-1)+(BF-1)*M+0*M*M],MulC(C[(BG-1)+0*M+1*M*M],CD));
_9:
 end;
CC := V+1;
if ( CC > M )
 then goto _8;
for BG:=CC to M do
 begin
  B3[(BG-1)+(BF-1)*M+0*M*M] := AddC(B3[(BG-1)+(BF-1)*M+0*M*M],MulC(C[(BG-1)+0*M+1*M*M],CD));
_10:
 end;
goto _8;
_11:
for I:=1 to M do
 begin
  B3[(I-1)+(J-1)*M+0*M*M] := C[(I-1)+0*M+1*M*M];
_12:
 end;
BE := J+1;
if ( BE > M )
 then goto _100;
for BF:=BE to M do
 begin
  B3[(V-1)+(BF-1)*M+0*M*M] := MulC(B3[(V-1)+(BF-1)*M+0*M*M],B3[(V-1)+(W-1)*M+0*M*M]);
_13:
 end;
_100:
BE := J-1;
if ( BE = 0 )
 then goto _101;
for BF:=1 to BE do
 begin
  B3[(V-1)+(BF-1)*M+0*M*M] := MulC(B3[(V-1)+(BF-1)*M+0*M*M],B3[(V-1)+(W-1)*M+0*M*M]);
_14:
 end;
_101:
V := V+1;
W := W+1;
if ( V > M ) 
 then goto _15;
if ( W <= M ) 
 then goto _3;
_15:
I := 1;
_16:
BH := IntSign(1,1-M);
Z := M-BH;
_17:
Z := Z+BH;
J := Q[Z-1];
BS := B3[(I-1)+(J-1)*M+0*M*M];
B3[(I-1)+(J-1)*M+0*M*M] := B3[(I-1)+(Z-1)*M+0*M*M];
B3[(I-1)+(Z-1)*M+0*M*M] := BS;
if ( Z <> 1 ) 
 then goto _17;
I := I+1;
if ( I <= M ) 
 then goto _16;
_18:
for I:=1 to M do
 begin
_19:
  Y[(I-1)+0*M] := Cmplx(0.0,0.0);
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_20:
    Y[(I-1)+0*M] := AddC(Y[(I-1)+0*M],MulC(B3[(I-1)+(J-1)*M+0*M*M],B[(J-1)+0*M]));
   end;
 end;
D := 1;
_21:
D := D+1;
if ( D > P ) 
 then goto _90;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_22:
    C[(I-1)+(J-1)*M+2*M*M] := Cmplx(0.0,0.0);
   end;
 end;
for K:=2 to D do
 begin
  for E:=1 to M do
   begin
    for J:=1 to M do
     begin
      for I:=1 to M do
       begin
        C[(I-1)+(E-1)*M+2*M*M] := AddC(C[(I-1)+(E-1)*M+2*M*M],MulC(A1[(I-1)+(J-1)*M+(K-1)*M*M],B3[(J-1)+(E-1)*M+(K-2)*M*M]));
_23:
       end;
_231:
     end;
_232:
   end;
_233:
 end;
for J:=1 to M do
 begin
  E := L[J-1];
  Q[J-1] := E;
  for I:=1 to M do
   begin
_24:
    C[(I-1)+(J-1)*M+1*M*M] := Conjg(C[(I-1)+(E-1)*M+2*M*M]);
   end;
 end;
for I:=1 to M do
 begin
  E := L[I-1];
  if ( E = I ) 
   then goto _25;
  L[I-1] := I;
  L[E-1] := E;
  for J:=1 to M do
   begin
    A := C[(E-1)+(J-1)*M+1*M*M];
    C[(E-1)+(J-1)*M+1*M*M] := C[(I-1)+(J-1)*M+1*M*M];
    C[(I-1)+(J-1)*M+1*M*M] := A;
//_25:
   end;
_25:
 end;
for I:=1 to M do
 begin
_26:
  L[I-1] := Q[I-1];
 end;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_27:
    C[(I-1)+(E-1)*M+0*M*M] := Cmplx(0.0,0.0);
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_28:
      C[(I-1)+(E-1)*M+0*M*M] := AddC(C[(I-1)+(E-1)*M+0*M*M],MulC(C[(I-1)+(J-1)*M+1*M*M],C[(J-1)+(E-1)*M+2*M*M]));
     end;
   end;
 end;
for J:=1 to M do
 begin
  C[(J-1)+(J-1)*M+0*M*M] := SubC(C[(J-1)+(J-1)*M+0*M*M],Cmplx(1.0,0.0));
  for I:=1 to M do
   begin
_29:
    C[(I-1)+(J-1)*M+0*M*M] := SubC(Cmplx(0.0,0.0),C[(I-1)+(J-1)*M+0*M*M]);
   end;
 end;
if ( M > 1 ) 
 then goto _30;
C[0+0*M+0*M*M] := DivC(Cmplx(1.0,0.0),C[0+0*M+0*M*M]);
goto _46;
_30:
BA := 1;
BB := 1;
_31:
J := BB;
BT := BA;
BW := Cmplx(0.0,0.0);
for I:=BA to M do
 begin
  CI := Cmplx(Cabs(C[(I-1)+(J-1)*M+0*M*M]),0.0);
  if ( (Cabs(BW)) >=     (Cabs(CI)) ) 
   then goto _32;
  BW := CI;
  BT := I;
_32:
 end;
for J:=1 to M do
 begin
  CX := C[(BT-1)+(J-1)*M+0*M*M];
  C[(BT-1)+(J-1)*M+0*M*M] := C[(BA-1)+(J-1)*M+0*M*M];
  C[(BA-1)+(J-1)*M+0*M*M] := CX;
_33:
 end;
C[(BA-1)+1*M+1*M*M] := C[(BA-1)+(BB-1)*M+0*M*M];
Q[BA-1] := BT;
J := BB;
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := C[(I-1)+(J-1)*M+0*M*M];
_34:
 end;
BX := DivC(Cmplx(1.0,0.0),C[(BA-1)+0*M+1*M*M]);
for I:=1 to M do
 begin
  C[(I-1)+0*M+1*M*M] := SubC(Cmplx(0.0,0.0),MulC(C[(I-1)+0*M+1*M*M],BX));
_35:
 end;
C[(BA-1)+0*M+1*M*M] := BX;
BJ := 0;
_36:
BJ := BJ+1;
if ( M < BJ ) 
 then goto _39;
CL := C[(BA-1)+(BJ-1)*M+0*M*M];
CK := BA-1;
if ( CK = 0 )
 then goto _102;
for BK:=1 to CK do
 begin
  C[(BK-1)+(BJ-1)*M+0*M*M] := AddC(C[(BK-1)+(BJ-1)*M+0*M*M],MulC(C[(BK-1)+0*M+1*M*M],CL));
_37:
 end;
_102:
CK := BA+1;
if ( CK > M )
 then goto _36;
for BK:=CK to M do
 begin
  C[(BK-1)+(BJ-1)*M+0*M*M] := AddC(C[(BK-1)+(BJ-1)*M+0*M*M],MulC(C[(BK-1)+0*M+1*M*M],CL));
_38:
 end;
goto _36;
_39:
for I:=1 to M do
 begin
  C[(I-1)+(J-1)*M+0*M*M] := C[(I-1)+0*M+1*M*M];
_40:
 end;
BI := J+1;
if ( BI > M )
 then goto _103;
for BJ:=BI to M do
 begin
  C[(BA-1)+(BJ-1)*M+0*M*M] := MulC(C[(BA-1)+(BJ-1)*M+0*M*M],C[(BA-1)+(BB-1)*M+0*M*M]);
_41:
 end;
_103:
BI := J-1;
if ( BI = 0 )
 then goto _104;
for BJ:=1 to BI do
 begin
  C[(BA-1)+(BJ-1)*M+0*M*M] := MulC(C[(BA-1)+(BJ-1)*M+0*M*M],C[(BA-1)+(BB-1)*M+0*M*M]);
_42:
 end;
_104:
BA := BA+1;
BB := BB+1;
if ( BA > M ) 
 then goto _43;
if ( BB <= M ) 
 then goto _31;
_43:
I := 1;
_44:
BL := IntSign(1,1-M);
BD := M-BL;
_45:
BD := BD+BL;
J := Q[BD-1];
BY := C[(I-1)+(J-1)*M+0*M*M];
C[(I-1)+(J-1)*M+0*M*M] := C[(I-1)+(BD-1)*M+0*M*M];
C[(I-1)+(BD-1)*M+0*M*M] := BY;
if ( BD <> 1 ) 
 then goto _45;
I := I+1;
if ( I <= M ) 
 then goto _44;
_46:
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_47:
    C[(I-1)+(E-1)*M+1*M*M] := Cmplx(0.0,0.0);
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_48:
      C[(I-1)+(E-1)*M+1*M*M] := AddC(C[(I-1)+(E-1)*M+1*M*M],MulC(C[(I-1)+(J-1)*M+2*M*M],C[(J-1)+(E-1)*M+0*M*M]));
     end;
   end;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    C[(I-1)+(J-1)*M+1*M*M] := SubC(Cmplx(0.0,0.0),C[(I-1)+(J-1)*M+1*M*M]);
_49:
   end;
_50:
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_51:
    C[(I-1)+(J-1)*M+2*M*M] := Cmplx(0.0,0.0);
   end;
 end;
F := D;
G := F-1;
K := 0;
V := 57;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_52:
    B3[(I-1)+(E-1)*M+(F-1)*M*M] := Cmplx(0.0,0.0);
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_53:
      B3[(I-1)+(E-1)*M+(F-1)*M*M] := AddC(B3[(I-1)+(E-1)*M+(F-1)*M*M],MulC(B3[(I-1)+(J-1)*M+(G-1)*M*M],C[(J-1)+(E-1)*M+0*M*M]));
     end;
   end;
 end;
for I:=1 to M do
 begin
_54:
  Q[I-1] := L[I-1];
 end;
for J:=1 to M do
 begin
  E := L[J-1];
  if ( E = J ) 
   then goto _55;
  L[J-1] := J;
  L[E-1] := E;
  for I:=1 to M do
   begin
    A := C[(E-1)+(I-1)*M+1*M*M];
    C[(E-1)+(I-1)*M+1*M*M] := C[(J-1)+(I-1)*M+1*M*M];
    C[(J-1)+(I-1)*M+1*M*M] := A;
//_55:
   end;
_55:
 end;
for J:=1 to M do
 begin
_56:
  L[J-1] := Q[J-1];
 end;
_57:
K := K+1;
F := D-K;
G := F-1;
if ( K >= G ) 
 then goto _71;
_58:
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    Y[(J-1)+(P-1)*M] := Cmplx(0.0,0.0);
    for E:=1 to M do
     begin
_59:
      Y[(J-1)+(P-1)*M] := AddC(Y[(J-1)+(P-1)*M],MulC(C[(I-1)+(E-1)*M+2*M*M],C[(E-1)+(J-1)*M+0*M*M]));
     end;
   end;
  for J:=1 to M do
   begin
_60:
    C[(I-1)+(J-1)*M+2*M*M] := Y[(J-1)+(P-1)*M];
   end;
 end;
for J:=1 to M do
 begin
_61:
  Q[J-1] := N[J-1];
 end;
for I:=1 to M do
 begin
  E := N[I-1];
  if ( E = I ) 
   then goto _62;
  N[I-1] := I;
  N[E-1] := E;
  for J:=1 to M do
   begin
    A := B3[(E-1)+(J-1)*M+(F-1)*M*M];
    B3[(E-1)+(J-1)*M+(F-1)*M*M] := B3[(I-1)+(J-1)*M+(F-1)*M*M];
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := A;
//_62:
   end;
_62:
 end;
for J:=1 to M do
 begin
  N[J-1] := Q[J-1];
  for I:=1 to M do
   begin
_63:
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := Conjg(B3[(I-1)+(J-1)*M+(F-1)*M*M]);
   end;
 end;
for E:=1 to M do
 begin
  for J:=1 to M do
   begin
    B3[(J-1)+(E-1)*M+(K-1)*M*M] := Conjg(B3[(J-1)+(E-1)*M+(K-1)*M*M]);
    for I:=1 to M do
     begin
_64:
      C[(I-1)+(E-1)*M+2*M*M] := AddC(C[(I-1)+(E-1)*M+2*M*M],MulC(B3[(I-1)+(J-1)*M+(F-1)*M*M],C[(J-1)+(E-1)*M+1*M*M]));
     end;
   end;
 end;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_65:
    B3[(I-1)+(E-1)*M+(F-1)*M*M] := Cmplx(0.0,0.0);
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_66:
      B3[(I-1)+(E-1)*M+(F-1)*M*M] := AddC(B3[(I-1)+(E-1)*M+(F-1)*M*M],MulC(B3[(I-1)+(J-1)*M+(K-1)*M*M],C[(J-1)+(E-1)*M+1*M*M]));
     end;
   end;
 end;
for I:=1 to M do
 begin
  E := N[I-1];
  if ( E = I ) 
   then goto _67;
  N[I-1] := I;
  N[E-1] := E;
  for J:=1 to M do
   begin
    A := B3[(E-1)+(J-1)*M+(F-1)*M*M];
    B3[(E-1)+(J-1)*M+(F-1)*M*M] := B3[(I-1)+(J-1)*M+(F-1)*M*M];
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := A;
//_67:
   end;
_67:
 end;
for I:=1 to M do
 begin
_68:
  N[I-1] := Q[I-1];
 end;
for E:=1 to M do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_69:
      B3[(I-1)+(E-1)*M+(F-1)*M*M] := AddC(B3[(I-1)+(E-1)*M+(F-1)*M*M],MulC(B3[(I-1)+(J-1)*M+(G-1)*M*M],C[(J-1)+(E-1)*M+0*M*M]));
     end;
   end;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    A := Conjg(B3[(I-1)+(J-1)*M+(K-1)*M*M]);
    B3[(I-1)+(J-1)*M+(K-1)*M*M] := C[(I-1)+(J-1)*M+2*M*M];
_70:
    C[(I-1)+(J-1)*M+2*M*M] := A;
   end;
 end;
if ( V=57 ) then goto _57 else
if ( V=81 ) then goto _81;
_71:
if ( K = F ) 
 then goto _72;
V := 81;
goto _58;
_72:
for I:=1 to M do
 begin
_73:
  Q[I-1] := N[I-1];
 end;
for I:=1 to M do
 begin
  E := N[I-1];
  if ( E = I ) 
   then goto _74;
  N[I-1] := I;
  N[E-1] := E;
  for J:=1 to M do
   begin
    A := B3[(E-1)+(J-1)*M+(F-1)*M*M];
    B3[(E-1)+(J-1)*M+(F-1)*M*M] := B3[(I-1)+(J-1)*M+(F-1)*M*M];
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := A;
//_74:
   end;
_74:
 end;
for J:=1 to M do
 begin
  N[J-1] := Q[J-1];
  for I:=1 to M do
   begin
_75:
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := Conjg(B3[(I-1)+(J-1)*M+(F-1)*M*M]);
   end;
 end;
for E:=1 to M do
 begin
  for I:=1 to M do
   begin
_76:
    Y[(I-1)+(P-1)*M] := Cmplx(0.0,0.0);
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_77:
      Y[(I-1)+(P-1)*M] := AddC(Y[(I-1)+(P-1)*M],MulC(B3[(I-1)+(J-1)*M+(F-1)*M*M],C[(J-1)+(E-1)*M+1*M*M]));
     end;
   end;
  for I:=1 to M do
   begin
_78:
    C[(I-1)+(E-1)*M+1*M*M] := Y[(I-1)+(P-1)*M];
   end;
 end;
for E:=1 to M do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_79:
      C[(I-1)+(E-1)*M+1*M*M] := AddC(C[(I-1)+(E-1)*M+1*M*M],MulC(C[(I-1)+(J-1)*M+2*M*M],C[(J-1)+(E-1)*M+0*M*M]));
     end;
   end;
 end;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
_80:
    B3[(I-1)+(J-1)*M+(F-1)*M*M] := C[(I-1)+(J-1)*M+1*M*M];
   end;
 end;
_81:
for I:=1 to M do
 begin
_82:
  C[(I-1)+0*M+0*M*M] := B[(I-1)+(D-1)*M];
 end;
F := D;
for K:=2 to D do
 begin
  F := F-1;
  for J:=1 to M do
   begin
    E := N[J-1];
    Q[J-1] := L[J-1];
    for I:=1 to M do
     begin
_83:
      C[(I-1)+(J-1)*M+1*M*M] := Conjg(A1[(I-1)+(E-1)*M+(K-1)*M*M]);
     end;
   end;
  for I:=1 to M do
   begin
    E := L[I-1];
    if ( E = I )
     then goto _84;
    L[I-1] := I;
    L[E-1] := E;
    for J:=1 to M do
     begin
      A := C[(E-1)+(J-1)*M+1*M*M];
      C[(E-1)+(J-1)*M+1*M*M] := C[(I-1)+(J-1)*M+1*M*M];
      C[(I-1)+(J-1)*M+1*M*M] := A;
//_84:
     end;
_84:
   end;
  for I:=1 to M do
   begin
_85:
    L[I-1] := Q[I-1];
   end;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_86:
      C[(I-1)+0*M+0*M*M] := SubC(C[(I-1)+0*M+0*M*M],MulC(C[(I-1)+(J-1)*M+1*M*M],Y[(J-1)+(F-1)*M]));
     end;
   end;
_87:
 end;
for I:=1 to M do
 begin
_88:
  Y[(I-1)+(D-1)*M] := Cmplx(0.0,0.0);
 end;
for K:=1 to D do
 begin
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
_89:
      Y[(I-1)+(K-1)*M] := AddC(Y[(I-1)+(K-1)*M],MulC(B3[(I-1)+(J-1)*M+(K-1)*M*M],C[(J-1)+0*M+0*M*M]));
     end;
   end;
 end;
goto _21;
_90:
end;

end.
